using Amazon.Lambda.Core;
using Amazon.Lambda.SQSEvents;
using System.Text.Json;

[assembly: LambdaSerializer(typeof(Amazon.Lambda.Serialization.SystemTextJson.DefaultLambdaJsonSerializer))]

namespace ProcessChild;

public class Function
{
    public Response FunctionHandler(Person person, ILambdaContext context)
    {
        context.Logger.LogLine($"Person: {JsonSerializer.Serialize(person)}");

        return new Response { Message = $"Processing a child. {person}", IsAdult = person.IsAdult };
    }
}

public class Response
{
    public string Message { get; set; }
    public bool IsAdult { get; set; }  
}
public class Person
{
    public string FirstName { get; set; }
    public string LastName { get; set; }
    public DateTime DateOfBirth { get; set; }
    public int Age { get; set; }
    public bool IsAdult { get; set; }
    
    public override string ToString()
    {
        return $"{FirstName} {LastName} was born on {DateOfBirth}, is {Age} years old";
    }
}